// Copyright (C) 2002-2007 Nikolaus Gebhardt
// This file is part of the "Irrlicht Engine".
// For conditions of distribution and use, see copyright notice in irrlicht.h

#ifndef __I_PARTICLE_RING_EMITTER_H_INCLUDED__
#define __I_PARTICLE_RING_EMITTER_H_INCLUDED__

#include "IParticleEmitter.h"

namespace irr
{
namespace scene
{

//! A particle emitter for using with particle systems.
/** A Particle emitter emitts new particles into a particle system.
*/
class IParticleRingEmitter : public IParticleEmitter
{
public:

	//! destructor
	virtual ~IParticleRingEmitter() {};

	//! Set the center of the ring
	virtual void setCenter( core::vector3df center ) = 0;

	//! Set the radius of the ring
	virtual void setRadius( f32 radius ) = 0;

	//! Set the thickness of the ring
	virtual void setRingThickness( f32 ringThickness ) = 0;

	//! Get the center of the ring
	virtual const core::vector3df& getCenter() const = 0;

	//! Get the radius of the ring
	virtual const f32& getRadius() const = 0;

	//! Get the thickness of the ring
	virtual const f32& getRingThickness() const = 0;

    //! Writes attributes of the object.
    virtual void serializeAttributes(io::IAttributes* out, io::SAttributeReadWriteOptions* options) = 0;

    //! Reads attributes of the object.
    virtual s32 deserializeAttributes(s32 startIndex, io::IAttributes* in, io::SAttributeReadWriteOptions* options) = 0;

	//! Get emitter type
	virtual E_PARTICLE_EMITTER_TYPE getType() const { return EPET_BOX; }




};

} // end namespace scene
} // end namespace irr


#endif

